/*
NAME: 
DESCRIPTION: 导入资料;
PARAMETER:
    [
		{  
			name : 'path',
			title : '料号路径',
			type : 'LineEdit',
			property : {tool_tip : 'path'},
		},
		{  
			name : 'delJob',
			title : '料号存在是否删除',
			type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-09-01 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 导入资料 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> step信息 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>template");
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db
var PAR = {}
if ($.par) { PAR = $.par } else if ($.hasOwnProperty('script_parameter')){ PAR = JSON.parse($.script_parameter); }
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({ table: "pdm_aimdfm_task", data: { current_process_title: $.process_title }, where: { id: $.task_id } });
	}
}
var Status = 'ok';
var resultData = [];
var par = PAR;
var default_par = {
	auto_save: "No",
	delJob:"yes",
	units:"mm"
}
for(var key in default_par){ if (!par.hasOwnProperty(key) || par[key] == ""){ par[key] = default_par[key] }}
var job = Job;
try {
	if(_.isEmpty(job)){throw "参数job不存在"} else { job = job.toLowerCase() }
	var job_path = par.path;
	if(!par.path || par.path == ""){throw "无料号路径"}

	var dirs = fs.listDir(job_path, 1).filter(function(item){return item.type == "dir"})

	var jobDir = dirs.filter(function(v){return v.name === job})

	if(jobDir.length > 0){
		var jobFiles = fs.listDir( jobDir[0].path, -1) 
		var otherFiles = jobFiles.filter(function(file){return file.completeSuffix != "tgz"})
		jobFiles = jobFiles.filter(function(file){return file.completeSuffix == "tgz"})
		if(GEN.isJobExists({job:job}) && /yes/.test(par.delJob) ){GEN.deleteJob({job:job})}
		if(jobFiles.length > 0) {
			GEN.importJob({db:'genesis',path:jobFiles[0].path,name:job,analyze_surfaces:'yes'})	
		} else {
			GEN.createJob({name:job, db:"genesis"})
			GEN.createStep({job:job, name:"orig"})
			GEN.COM("input_show_page")
			GEN.COM("input_set_params,path=" + jobDir[0].path + ",job=" +job + ",step=orig")
			
			// otherFiles.forEach(function(item){   // ?
			// 	GEN.COM("input_identify,path=" + item.path + ",job=" +job)
			// })
		}
	}
	


	// 保存 
	if(/yes/ig.test(par.auto_save)){GEN.checkInout({job:job,mode:"out"}); GEN.saveJob({ job: job });GEN.checkInout({job:job,mode:"in"});GEN.closeJob({job:job});} else {GEN.checkInout({job:job,mode:"in"})}
	if (mode === "aimdfm") {
		$.QDfm.updateRow({table: "pdm_aimdfm_task",data: {progress: 33.33},where: { id: $.task_id }});
		if (GEN.hasError()) { Status = 'error';resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {status: Status,result_data: resultData};
		} else { resultData.push({ type: "info", title: "操作完成, 请注意检查!" }); return {status: Status,result_data: resultData}; }
	}else { return "Done" }
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"));IKM.msg(e);Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}