/*
NAME: 
DESCRIPTION: 设置零点;
PARAMETER:
    [
        {
            name : 'step',
			title : 'Step',
            type : 'LineEdit',
            property : {tool_tip : 'orig'},
        },
        {
			name : 'outline',
			title : '外形层',
			type : 'LineEdit',
			property : {tool_tip : '外形层,默认是ol'},
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-04-20 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 设置零点 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 资料路径 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>rename and sort");
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db
var PAR = {}
if ($.par) { PAR = $.par } else if ($.hasOwnProperty('script_parameter')){ PAR = JSON.parse($.script_parameter); }
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({ table: "pdm_aimdfm_task", data: { current_process_title: $.process_title }, where: { id: $.task_id } });
	}
}
var Status = 'ok';
var resultData = [];
var par = PAR;
var default_par = {
	outline:"ol",
	step:"orig",
	auto_save: "No",
	units:"mm"
}
for(var key in default_par){ if (!par.hasOwnProperty(key) || par[key] == ""){ par[key] = default_par[key] }}
var job = Job;
try {
	if(_.isEmpty(job)){throw "参数job不存在"} else { job = job.toLowerCase() }
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
	if(mode == "aimdfm"){ if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" } else { GEN.checkInout({job:job,mode:"out"}) } }
    var orig_step = par.step.toLowerCase()
    var stepList = GEN.getStepList({job:job})
    if(stepList.indexOf(orig_step) < 0){throw "step:"+orig_step+"不存在"}
	var outline = par.outline;
    // 判断参考层（outline）是否存在并不为空
	if(!GEN.isLayerExists({job:job,layer:outline})){throw "outline不存在"}
	stepList.forEach(function(step){
		GEN.openStep({job:job,name:step})
		GEN.units({type:par.units})
		// 将所有物件依据外形移动到零点
		GEN.workLayer({name:outline,display_number:2,clear_before:'yes'})
		GEN.selAllFeat()
		if(GEN.getSelectCount()>0){
			GEN.selClearFeature()
			var outline_symbol = GEN.getProfileLimits({job:job,step:step,units:'mm'})
			GEN.affectedLayer({affected:"yes",mode:"all"})
			GEN.selAllFeat()
			GEN.selMove({dx:-outline_symbol.xmin,dy:-outline_symbol.ymin})
			GEN.affectedLayer({affected:"no",mode:"all"})
			// 重新设置profile
			GEN.selCreateProfile()
			GEN.clearLayers()
			GEN.selClearFeature()
		} else {
			throw "outline无物件"
		}

	})

	// 保存 
	if(/yes/ig.test(par.auto_save)){GEN.checkInout({job:job,mode:"out"}); GEN.saveJob({ job: job });GEN.checkInout({job:job,mode:"in"});GEN.closeJob({job:job});} else {GEN.checkInout({job:job,mode:"in"})}
	if (mode === "aimdfm") {
		$.QDfm.updateRow({table: "pdm_aimdfm_task",data: {progress: 33.33},where: { id: $.task_id }});
		if (GEN.hasError()) { Status = 'error';resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {status: Status,result_data: resultData};
		} else { resultData.push({ type: "info", title: "操作完成, 请注意检查!" }); return {status: Status,result_data: resultData}; }
	}else { return "Done" }
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"));IKM.msg(e);Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}
