/*
NAME: 
DESCRIPTION: 按照某种规则自动设置smd,bga需要手动设置;
PARAMETER:
    [
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'},
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-09-01 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 设置smd属性 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> step信息 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>template");
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db
var PAR = {}
if ($.par) { PAR = $.par } else if ($.hasOwnProperty('script_parameter')){ PAR = JSON.parse($.script_parameter); }
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({ table: "pdm_aimdfm_task", data: { current_process_title: $.process_title }, where: { id: $.task_id } });
	}
}
var Status = 'ok';
var resultData = [];
var par = PAR;
var default_par = {
    step: "net",
	auto_save: "No",
	units:"mm"
}
for(var key in default_par){ if (!par.hasOwnProperty(key) || par[key] == ""){ par[key] = default_par[key] }}
var job = Job;
try {
	if(_.isEmpty(job)){throw "参数job不存在"} else { job = job.toLowerCase() }
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
    if(mode == "aimdfm"){ if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" } else { GEN.checkInout({job:job,mode:"out"}) } }
	var stepList = GEN.getStepList({job:job})
	stepList = stepList.filter(function(step){
		var reg = new RegExp(par.step,"ig")
		return reg.test(step)
	})
    var matrix = GEN.getMatrix({job:job})
    var outLayers = Object.keys(matrix).filter(function(key){
        var info = matrix[key]
        return info.context == "board" && info.layer_type == "signal" && /top|bottom/.test(info.side)
	})
    stepList.forEach(function(step) {
        GEN.openStep({ job: job, name: step });
        GEN.clearLayers(); //清除层显示
        GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
        GEN.COM("sel_options,clear_mode=clear_after,display_mode=all_layers,area_inout=inside,area_select=select,select_mode=standard,area_touching_mode=exclude");
        GEN.units({ type: par.units }); //单位初始化
        GEN.zoomHome(); //窗口显示回到原始位置
        GEN.selClearFeature()

        var ref_drl = "drl"

        if(!GEN.isLayerExists({job:job, layer:"via"})){
            GEN.workLayer({name:"drl",display_number:2,clear_before:'yes'})
            GEN.selectByFilter({attribute:[{attribute:".drill",option:"via"}]})
            if(GEN.getSelectCount() > 0) {
                GEN.selCopyOther({dest:'layer_name',target_layer:'via',invert:'no',dx:0,dy:0,size:0});
                ref_drl = "via"
            }
        } else {
            ref_drl = "via"
        }


        outLayers.forEach(function(layer){
            GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
            GEN.COM("chklist_single,action=valor_cleanup_set_smd,show=yes")
            GEN.COM("chklist_pclear")
            GEN.COM("chklist_cupd,chklist=valor_cleanup_set_smd,nact=1,params=((pp_layer="+layer+")(pp_drill=No)(pp_rotate=No)(pp_ignore_covered=Yes)(pp_sm=No)(pp_types=Square\;Rect\;Oval\;Round)(pp_other=)(pp_delete=No)),mode=regular")
            GEN.COM("chklist_pcopy,chklist=valor_cleanup_set_smd,nact=1")
            GEN.COM("chklist_close,chklist=valor_cleanup_set_smd,mode=hide")
            if(GEN.isChklistExists({job:job,step:step,chklist:'setsmdchk'})){ GEN.COM("chklist_delete,chklist=setsmdchk") }
            GEN.COM("chklist_create,chklist=setsmdchk")
            GEN.COM("chklist_show,chklist=setsmdchk")
            GEN.COM("chklist_ppaste,chklist=setsmdchk,row=0")
            GEN.COM("chklist_cupd,chklist=setsmdchk,nact=1,params=((pp_layer="+layer+")(pp_drill=No)(pp_rotate=No)(pp_ignore_covered=Yes)(pp_sm=No)(pp_types=Square\;Rect\;Oval\;Round)(pp_other=)(pp_delete=No)),mode=regular")
            GEN.COM("chklist_run,chklist=setsmdchk,nact=1,area=local")
            GEN.chklistClose({chklist:"setsmdchk"})
            GEN.COM("chklist_delete,chklist=setsmdchk")


            GEN.selectByFilter({feat_types:"pad"})
            GEN.selectByFilter({attribute:".smd",operation:"unselect"})

            if(GEN.getSelectCount() > 0) {
                if(GEN.isLayerExists({job:job, layer:layer + "_tmp"})) {GEN.deleteLayer({job:job, layer:[layer + "_tmp"]})}
                GEN.selMoveOther({target_layer:layer + "_tmp",invert:'no',dx:0,dy:0,size:0})
                GEN.workLayer({name:layer + "_tmp",display_number:2,clear_before:'yes'})
                GEN.COM("filter_set,filter_name=popup,update_popup=no,feat_types=pad")
                GEN.COM("sel_ref_feat,layers=drl,use=filter,mode=disjoint,pads_as=shape,f_types=line\;pad\;surface\;arc\;text,polarity=positive\;negative,include_syms=,exclude_syms=")
                if(GEN.getSelectCount() > 0) {
                        GEN.COM("cur_atr_reset")
                        GEN.COM("cur_atr_set,attribute=.smd") 
                        GEN.COM("sel_change_atr,mode=add")
                }
                GEN.selMoveOther({target_layer:layer,invert:'no',dx:0,dy:0,size:0})
            }
            GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
            GEN.selectByFilter({feat_types:"pad"})
            GEN.selectByFilter({attribute:".smd",operation:"unselect"});
            var Feats = GEN.getFeatures({job:job,step:step,layer:layer,options:"select",units:"mm"})
            GEN.selMoveOther({target_layer:layer + "_tmp",invert:'no',dx:0,dy:0,size:0})
            GEN.workLayer({name:layer + "_tmp",display_number:2,clear_before:'yes'})
            var rsyms =  Feats.reduce(function(a,b){
                if(/^r\d/.test(b.symbol) && a.indexOf(b.symbol) < 0) {
                    a.push(b.symbol)
                }
                return a
            }, [])
            GEN.selectByFilter({include_syms:rsyms.join(";")});
            if(GEN.getSelectCount() > 0) {
                GEN.selMoveOther({target_layer:layer,invert:'no',dx:0,dy:0,size:0})
                GEN.selRefFeat({layers:ref_drl, use:"filter",mode:"touch"})
                if(GEN.getSelectCount() > 0) {
                    GEN.displayLayer({name:ref_drl,number:1})
                    GEN.COM("cur_atr_reset")
					GEN.COM("cur_atr_set,attribute=.smd") 
					GEN.COM("sel_change_atr,mode=add")
                   	GEN.selMoveOther({target_layer:layer,invert:'no',dx:0,dy:0,size:0})
                } else {
                    GEN.selMoveOther({target_layer:layer,invert:'no',dx:0,dy:0,size:0})
                }
            }
        })
        
    })
   

	// 保存 
	if(/yes/ig.test(par.auto_save)){GEN.checkInout({job:job,mode:"out"}); GEN.saveJob({ job: job });GEN.checkInout({job:job,mode:"in"});GEN.closeJob({job:job});} else {GEN.checkInout({job:job,mode:"in"})}
	if (mode === "aimdfm") {
		$.QDfm.updateRow({table: "pdm_aimdfm_task",data: {progress: 33.33},where: { id: $.task_id }});
		if (GEN.hasError()) { Status = 'error';resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {status: Status,result_data: resultData};
		} else { resultData.push({ type: "info", title: "操作完成, 请注意检查!" }); return {status: Status,result_data: resultData}; }
	}else { return "Done" }
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"));IKM.msg(e);Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}

