/*
NAME: 
DESCRIPTION: 大孔转outline;
PARAMETER:
    [
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'},
		},
		{
			name : 'outline',
			title : 'outline',
			type : 'LineEdit',
			property : {tool_tip : 'outline层'},
		}
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-09-01 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 大孔转outline </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> step信息 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>template");
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db
var PAR = {}
if ($.par) { PAR = $.par } else if ($.hasOwnProperty('script_parameter')){ PAR = JSON.parse($.script_parameter); }
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({ table: "pdm_aimdfm_task", data: { current_process_title: $.process_title }, where: { id: $.task_id } });
	}
}
var Status = 'ok';
var resultData = [];
var par = PAR;
var default_par = {
	step: "edit",
	outline:"ol",
	auto_save: "No",
	units:"mm"
}
for(var key in default_par){ if (!par.hasOwnProperty(key) || par[key] == ""){ par[key] = default_par[key] }}
var job = Job;
try {
	if(_.isEmpty(job)){throw "参数job不存在"} else { job = job.toLowerCase() }
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
    if(mode == "aimdfm"){ if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" } else { GEN.checkInout({job:job,mode:"out"}) } }
	var stepList = GEN.getStepList({job:job})
	stepList = stepList.filter(function(step){
		var reg = new RegExp(par.step,"ig")
		return reg.test(step)
	})
	
	var matrix = GEN.getMatrix({job:job})

    var DrillLayer = Object.keys(matrix).reduce(function(a,b){
        if(matrix[b].context == "board" && matrix[b].layer_type == 'drill'){
            a.push(b)
        }
        return a;
	},[])
	var outline = par.outline
	var ol_tmp = outline + "_tmp"

    stepList.forEach(function(step){
        GEN.openStep({job:job,name:step})
		GEN.clearLayers();  //清除层显示
		GEN.affectedLayer({ mode: 'all', affected: 'no' });  //设置影响层全部不影响
		GEN.COM("sel_options,clear_mode=clear_after,display_mode=all_layers,area_inout=inside,area_select=select,select_mode=standard,area_touching_mode=exclude");
		GEN.units({ type: par.units }); 
        GEN.zoomHome(); 
        if(GEN.isLayerExists({job:job, layer:"pt-rou"})){GEN.deleteLayer({job:job,layer:["pt-rou"]})}
        if(GEN.isLayerExists({job:job, layer:ol_tmp})){GEN.deleteLayer({job:job,layer:[ol_tmp]})}
		GEN.createLayer({job:job,layer:'pt-rou',context:'misc',type:'rout'})

		DrillLayer.forEach(function(layer){
			var feats = GEN.getFeatures({job:job,step:step,layer:layer, options:"feat_index", units:"mm"})
			GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
			feats.forEach(function(item) {
				var index = item.index
				if(item.type == "line") { // 槽孔
					var width = parseFloat(item.symbol.slice(1))
					var length = width + Math.sqrt((item.xe - item.xs)*(item.xe - item.xs) + (item.ye - item.ys)*(item.ye - item.ys))*1000
					if(item.attributes && item.attributes.indexOf(".drill=non_plated") >= 0) {
						if(width >= 6050 || length>= 12000){
							GEN.selLayerFeat({layer:layer, index:index,operation:"select"});
							if(GEN.getSelectCount() > 0){GEN.selMoveOther({target_layer:'ol_tmp',invert:'no',dx:0,dy:0,size:0})}
						}
					} else if (item.attributes && item.attributes.indexOf(".drill=plated") >= 0) {
						if(width >= 6050 || length>= 12000){
							GEN.selLayerFeat({layer:layer, index:index,operation:"select"});
							if(GEN.getSelectCount() > 0){GEN.selMoveOther({target_layer:'pt-rou',invert:'no',dx:0,dy:0,size:0})}
						}
					}
				}
				if(item.type == "pad") {
					var size = parseFloat(item.symbol.slice(1));
					if(item.attributes && item.attributes.indexOf(".drill=non_plated") >= 0) {
						if(size > 6000 ){
							GEN.selLayerFeat({layer:layer, index:index,operation:"select"});
							if(GEN.getSelectCount() > 0){GEN.selMoveOther({target_layer:'ol_tmp',invert:'no',dx:0,dy:0,size:0})}
						}
					} else if (item.attributes && item.attributes.indexOf(".drill=plated") >= 0) {
						if(size > 12000 ){
							GEN.selLayerFeat({layer:layer, index:index,operation:"select"});
							if(GEN.getSelectCount() > 0){GEN.selMoveOther({target_layer:'pt-rou',invert:'no',dx:0,dy:0,size:0})} 
						}
					}
				}
			})
			// 将ol_tmp  和 pt-rou的转为非闭合图形
			GEN.clearLayers()
		})
        GEN.clearLayers();
		[ol_tmp, "pt-rou"].forEach(function(v){
			if(GEN.isLayerExists({job:job, layer:v})) {
				GEN.affectedLayer({affected:'yes',layer:v,clear_before:"no"})
			}
		})
		GEN.COM("sel_contourize,accuracy=0,break_to_islands=yes,clean_hole_size=0,clean_hole_mode=x_and_y")
		GEN.COM("sel_surf2outline,width=200")
		GEN.affectedLayer({affected:'no',mode:'all'})
		if(GEN.isLayerExists({job:job, layer:ol_tmp})) {
			GEN.workLayer({name:'ol_tmp',display_number:2,clear_before:'yes'})
			GEN.selMoveOther({target_layer:outline,invert:'no',dx:0,dy:0,size:0})
			GEN.deleteLayer({job:job, layer:[ol_tmp]})
		}
		if(GEN.isLayerExists({job:job, layer:"pt-rou"})){GEN.deleteLayer({job:job,layer:["pt-rou"]})}
	})
	// 保存 
	if(/yes/ig.test(par.auto_save)){GEN.checkInout({job:job,mode:"out"}); GEN.saveJob({ job: job });GEN.checkInout({job:job,mode:"in"});GEN.closeJob({job:job});} else {GEN.checkInout({job:job,mode:"in"})}
	if (mode === "aimdfm") {
		$.QDfm.updateRow({table: "pdm_aimdfm_task",data: {progress: 33.33},where: { id: $.task_id }});
		if (GEN.hasError()) { Status = 'error';resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {status: Status,result_data: resultData};
		} else { resultData.push({ type: "info", title: "操作完成, 请注意检查!" }); return {status: Status,result_data: resultData}; }
	}else { return "Done" }
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"));IKM.msg(e);Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}
