/*
NAME: 
DESCRIPTION: 填小细丝;
PARAMETER:
    [
		{
			name : 'step_fliter',
			title : 'Step过滤',
			type : 'LineEdit',
			property : {tool_tip : 'unit'},
		},
		{
            name : 'checklist_cfg',
			title : 'checklist配置',
			type : 'TextEdit',
            property : {tool_tip : 'checklist配置'},
            setter:function(obj,value,self){
                obj.setPlainText(value);
            },
            getter:function(obj,self){
                return obj.plainText
            }
		},
		{
			name : 'layer_type',
			title : '工作层',
			type : 'ComboBox',
			property : {
			    size_policy:'Expanding,Fixed',
			    item_list:[
			        {name:'outer',text:'outer'},
			        {name:'inner',text:'inner'},
			        {name:'power_ground',text:'power_ground'},
			        {name:'all',text:'all'}
			    ],
			    tool_tip:'分析模式必须设置，未设定则退出'
			},
			pack : {row:1,column:1},
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-04-28 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 填小细丝 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 配置 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>JTG_PUB_pos_add_sliver_aim start");
/* question
    ?
*/
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var PAR = {}
if ($.par) {
	PAR = $.par
} else if ($.hasOwnProperty('script_parameter')){
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({
			table: "pdm_aimdfm_task",
			data: {
				current_process_title: $.process_title
			},
			where: { id: $.task_id }
		});
	}
}
var Status = 'ok';
var resultData = [];

try {
	var par = PAR;
	var default_par = {  // par默认参数？
		step_fliter:"edit",
		units: "mm",
		layer_type:"inner",
		auto_save: "no"
	}
	for(var key in default_par){  // 设置默认属性
		if (!par.hasOwnProperty(key) || par[key] == ""){
			par[key] = default_par[key]
		}
	}
	
	if(_.isEmpty(Job)){throw "参数Job不存在"}
    var job = Job.toLowerCase()
    // 料号验证
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
	if(mode == "aimdfm"){
        if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" }
        GEN.checkInout({job:job,mode:"out"});
    }
	
	// 脚本开始
	var checklist_cfg = false;
	if(par.checklist_cfg && par.checklist_cfg != "") {
		// checklist_cfg = eval(par.checklist_cfg)
		checklist_cfg = JSON.parse(par.checklist_cfg)
	}
	var layer_config = {
		outer: {layer_type:"signal", side:"top|bottom", context:"board", polarity:"positive"},
		inner: {layer_type:"signal", side:"inner", context:"board", polarity:"positive"},
		all: {layer_type:"signal", context:"board", polarity:"positive"},
		power_ground: {layer_type:"power_ground", side:"inner", context:"board", polarity:"negative"},
	} 
	var layer_cfg
	if(par.layer_type != ""){
		layer_cfg = layer_config[par.layer_type]
	}
	var matrix = GEN.getMatrix({job:job})
	var n_layers = Object.keys(matrix).sort(function(a,b){return matrix[a].row - matrix[b].row})
	.filter(function(key){
		var val = matrix[key]
		var flag = true
		if(!layer_cfg){ return false}
		for(var k in layer_cfg){
			var tmp_reg = new RegExp(layer_cfg[k], "ig")
			if(!tmp_reg.test(val[k])){
				flag = false
			}
		}
		return flag
	})
	if(n_layers.length == 0){throw "can not find layer"}
	var stepList = GEN.getStepList({job:job})
	if(par.step_fliter != ""){
		stepList = stepList.filter(function(v){
			var step_reg = new RegExp(par.step_fliter)
			return step_reg.test(v)})
	}

	stepList.forEach(function(step){
		GEN.openStep({job:job, name:step})
		GEN.units({type:par.units})
		GEN.clearLayers()
		GEN.affectedLayer({affected:"yes", layer:n_layers, clear_before:"yes"})
		if(checklist_cfg){
			Object.keys(checklist_cfg).forEach(function(key){
				if(GEN.getChecklist({job:"genesislib",step:"checklib"}).indexOf(key) > 0){
					var v = checklist_cfg[key]
					if(GEN.isChklistExists({job:job,step:step,chklist:key})){
						GEN.COM("chklist_delete", { chklist: key })
					} 
					GEN.chklistFromLib({chklist:key})
					v.forEach(function(nact){
						GEN.COM('chklist_open,chklist='+key)
						GEN.COM('chklist_show,chklist='+key)
						GEN.chklistRun({chklist:key, nact:nact })
					})
				}
			})
		}else {
			var pp_mode = ["X or Y", "X and Y", "Width"]
			pp_mode.forEach(function(mode){
				// 打开去空洞命令valor_dfm_clean_holes，影响层设置signal&inner&positive，
				//  Max Size设置为75，Overlap设置4，Select By选择，Action选择Cover islands和Cover holes，Fill With选择Surfaces，Work On选择Features；
				GEN.COM("chklist_single",{action:'valor_dfm_clean_holes',show:'yes'});
				GEN.COM("chklist_cupd",{chklist:'valor_dfm_clean_holes',nact:1,
	params:"((pp_layer=.affected)(pp_size=75)(pp_overlap=4)(pp_mode="+mode+")(pp_hi=Cover holes)(pp_cover_f=Surfaces))",
				mode:'regular'});
				GEN.COM("chklist_run",{chklist:'valor_dfm_clean_holes',nact:1,area:'profile'});
				GEN.COM("chklist_res_show",{chklist:'valor_dfm_clean_holes',nact:1,'x':0,'y':0,w:0,h:0});
				GEN.COM("chklist_close",{chklist:'valor_dfm_clean_holes',mode:'hide'});
			})
			GEN.COM("chklist_single",{action:'valor_dfm_smooth_data',show:'yes'});
			GEN.COM("chklist_cupd",{chklist:'valor_dfm_smooth_data',nact:1,
	params:"((pp_layer=.affected)(pp_max_sliver=75)(pp_max_angle=90)(pp_space=75)(pp_overlap=13)(pp_pg=Yes)(pp_acute=Yes)(pp_mode=Repair)(pp_copper=Features))",
			mode:'regular'});
			GEN.COM("chklist_run",{chklist:'valor_dfm_smooth_data',nact:1,area:'profile'});
			GEN.COM("chklist_res_show",{chklist:'valor_dfm_smooth_data',nact:1,'x':0,'y':0,w:0,h:0});
			GEN.COM("chklist_close",{chklist:'valor_dfm_smooth_data',mode:'hide'});
			// 打开补锐角命令valor_dfm_smooth_data ，设置影响层为positive&board&inner ，  Max-sliver设置为75，Angle设置90，Max Pg Space设置75 Overlap设置13，
			// Fix  Clearances选择Yes，Mode选择Repair，Work On选择Features；
		}
	})
    GEN.deleteLayer({job:job,layer:n_layers.map(function(v){return v + "+++"})})
	// 保存 
	if(/yes/ig.test(par.auto_save)){
		GEN.checkInout({job:job,mode:"out"})  // 结束保存料号 关闭料号
		GEN.saveJob({ job: job });
		GEN.checkInout({job:job,mode:"in"})
		GEN.closeJob({job:job})
	} else {
		GEN.checkInout({job:job,mode:"in"})
	}
    console.log("========================>JTG_PUB_pos_add_sliver_aim end");
	if (mode === "aimdfm") {
		$.QDfm.updateRow({
			table: "pdm_aimdfm_task",
			data: {
				progress: 33.33
			},
			where: { id: $.task_id }
		});
		if (GEN.hasError()) {
			Status = 'error';
			resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {
				status: Status,
				result_data: resultData
			};
		} else {
			resultData.push({ type: "info", title: "操作完成, 请注意检查!" });
			return {
				status: Status,
				result_data: resultData
			};
		}
	}else {
		return "Done"
	}
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"))
	IKM.msg(e)
    Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}