/*
NAME: 
DESCRIPTION: 蚀刻文字处理;
PARAMETER:
    [
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'},
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-09-01 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 蚀刻文字处理 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> step信息 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>template");
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db
var PAR = {}
if ($.par) {
	PAR = $.par
} else if ($.hasOwnProperty('script_parameter')){
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({
			table: "pdm_aimdfm_task",
			data: {
				current_process_title: $.process_title
			},
			where: { id: $.task_id }
		});
	}
}
var Status = 'ok';
var resultData = [];

try {
	var par = PAR;
	var default_par = {
		step: "edit",
		auto_save: "No",
		units:"mm"
	}
	for(var key in default_par){  // 设置默认属性
		if (!par.hasOwnProperty(key) || par[key] == ""){
			par[key] = default_par[key]
		}
	}
	if(_.isEmpty(Job)){throw "参数Job不存在"}
	var job = Job.toLowerCase()
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
    if(mode == "aimdfm"){
        if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" }
        GEN.checkInout({job:job,mode:"out"});
	}
	
	var steplist = GEN.getStepList({job:job})
	steplist = steplist.filter(function(v){
		var tmpreg = new RegExp(par.step,"ig")
		return tmpreg.test(v)
	})
	var outLayers = [];

	var matrix = GEN.getMatrix({job:job})
	for (var key in matrix) {
		var layer_info = matrix[key];
		if(layer_info.context == "board" && layer_info.layer_type == "signal" && /top|bot/.test(layer_info.side)){
			outLayers.push(key)
		}
	}

	var scale_lengthy = 5;  // 长宽最短距离 mm
	var scale_lengthx = 3;  // 长宽最短距离 mm

	steplist.forEach(function(step) {
		GEN.openStep({job:job, name:step})
        GEN.units({type:"mm"})
		GEN.affectedLayer({affected:'no',mode:'all'})
		
		outLayers.forEach(function(layer){
			GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
			var tmp = layer + "_tmp";
			if(GEN.isLayerExists({job:job,layer:tmp})){GEN.deleteLayer({job:job,layer:tmp})}
			// 手动选择蚀刻字
			IKM.msg("将暂停，请选择需要优化的蚀刻字")
			GEN.PAUSE("please select etc fonts")
			if(GEN.getSelectCount() > 0) {
				GEN.selMoveOther({target_layer:tmp,invert:'no',dx:0,dy:0,size:0})
				GEN.workLayer({name:tmp,display_number:2,clear_before:'yes'})
				
				// 获取最小蚀刻大小
				var etc_size = 650;
				// 缩小最小蚀刻大小
				var flag = true;
				var count = 0;
				while (flag) {
					var tmp_2 = tmp + "2";
					if(GEN.isLayerExists({job:job,layer:tmp_2})){GEN.deleteLayer({job:job,layer:tmp_2})}
					GEN.selCopyOther({dest:'layer_name',target_layer:tmp_2,invert:'no',dx:0,dy:0,size:-etc_size})
					GEN.selRefFeat({layers:tmp_2, use:"filter",mode:"disjoint"})
					count++;
					if(GEN.getSelectCount() > 0 ){
						GEN.selResize({size:20});
					} else {
						flag = false
					}
					if(count >= 10){flag = false}
					GEN.deleteLayer({job:job,layer:tmp_2})
				}

				var features = GEN.getFeatures({job:job, step:step, layer:tmp, surface:1,units:"mm"})
				features.forEach(function(item){
					if(item.feats){
						var surface_data = profile2Polygon(item.feats)
						var limits = polygonLimits(surface_data);
						// 根据limits信息将文字放大
						var x_center_k = 1;
						var y_center_k = 1;
						var x_center = Number(limits.xmin) + limits.xsize/2;
						if(limits.xsize < scale_lengthx){ x_center_k = scale_lengthx/limits.xsize}
						var y_center = Number(limits.ymin) + limits.ysize/2;
						if(limits.ysize < scale_lengthy){ y_center_k = scale_lengthy/limits.ysize}
						GEN.selLayerFeat({layer:tmp, index:item.index,operation:"select"})
						if(GEN.getSelectCount() > 0){
							GEN.selTransform({mode:'anchor',oper:'scale',x_anchor:x_center,y_anchor:y_center,x_scale:x_center_k,y_scale:y_center_k}) 
						}
					}
				})
				


				GEN.workLayer({name:tmp,display_number:2,clear_before:'yes'})
				GEN.selMoveOther({target_layer:layer,invert:'no',dx:0,dy:0,size:0})
				GEN.deleteLayer({job:job, layer:tmp})
			}
		})

	})
	
	// 保存 
	if(/yes/ig.test(par.auto_save)){
		GEN.checkInout({job:job,mode:"out"})  // 结束保存料号 关闭料号
		GEN.saveJob({ job: job });
		GEN.checkInout({job:job,mode:"in"})
		GEN.closeJob({job:job})
	} else {
		GEN.checkInout({job:job,mode:"in"})
	}

	if (mode === "aimdfm") {
		$.QDfm.updateRow({table: "pdm_aimdfm_task",data: {progress: 33.33},where: { id: $.task_id }});
		if (GEN.hasError()) {
			Status = 'error';resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {status: Status,result_data: resultData};
		} else {
			resultData.push({ type: "info", title: "操作完成, 请注意检查!" });
			return {status: Status,result_data: resultData};
		}
	}else {
		return "Done"
	}
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"))
	IKM.msg(e)
    Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}

function profile2Polygon(feat) {
	var info = [];
	feat.forEach(function(v){
		if (/^#O. ([\S]+) ([\S]+)/.test(v)) {
			info.push({
				x: RegExp.$1 - 0,
				y: RegExp.$2 - 0
			})
		}
	})
	return info
}

function polygonLimits(par) {
	var tmpx = par.map(function(v){return v.x}).sort(function(a,b){return a-b})
	var xmin = tmpx[0]
	var xmax = tmpx[tmpx.length - 1]
	var tmpy = par.map(function(v){return v.y}).sort(function(a,b){return a-b})
	var ymin = tmpy[0]
	var ymax = tmpy[tmpy.length - 1]
	var xsize = xmax - xmin;
	var ysize = ymax - ymin;
	return {xmin:xmin, xmax:xmax, ymin:ymin, ymax:ymax, xsize:xsize, ysize:ysize};
}