=head
 NAME: ZDA_MI_upload_orig_dril_table
 DESCRIPTION: 上传原稿钻孔信息
 PARAMETER:
	[
		{
			name : 'pcs_step_filter',
			type : 'LineEdit',
			title : 'Pcs Step过滤',
			pack : {row:0,column:1},
			property:{tool_tip:'脚本参数若未设置，则手动选择'},
		},
		{
			name : 'array_step_filter',
			type : 'LineEdit',
			title : 'Array Step过滤',
			pack : {row:0,column:1},
			property:{tool_tip:'脚本参数若未设置，则手动选择'},
		},
		{
			name : 'save_job',
			title : '保存料号',
			type : 'RadioBox',
			property : {
				size_policy:'Expanding,Fixed',
				item_list:[
					{name:'Yes',text:'Yes'},
					{name:'No',text:'No'},
				],
				tool_tip:'脚本结束后自动保存料号，未设定，默认为No'
			},
			pack : {row:1,column:1},
		}
	]
	
 VERSION_HISTORY:
	V1.00 2020-12-02 Scott 
	    1.新版本
 HELP:
	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		  <p> 上传原稿钻孔信息 </p>
		  <br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<font color="#008000"><p> ● 无</p></font>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		  <p> ● 无 </p>
		  <br>
	</body></html>
  
=cut

use strict;
use Encode;
use utf8;
use Data::Dump 'dump';
use JSON;
my $json = new JSON;
my ($Job,$Step) = ($JOB,undef);
my $Return = 'done';
$PAR->{units} = 'mm';
##
$PAR->{step_filter} = '.*' unless $PAR->{step_filter};
$PAR->{save_job} = 'no' unless $PAR->{save_job};


# my $num = $IKM->get_workflow_process_index(-flow_id=>8,-step_id=>47);
# $GUI->debug(dump($num));
doScript("ECS_Public");
# my %matrix = $GEN->getMatrix(job=>$Job,type=>'hash');
my $matrix = ANALYSIS_STACKUP(job=>$Job);
my %matrix = %{$matrix};

# # 	my @drill = $GUI->select_layer_v2(
# # 		-title=>'请选择工作层别',
# # 		-layermatrix=>\%matrix,
# # 		# -default => [keys %{$tmp_matrix{drill}}],
# # 		-selectmode => 'multiple');#single
# # 	return 'Cancel' unless(@drill);


# # $GUI->debug(dump(@drill));
# return 'cancel';

my $customer_code = $IKM->get_jobinfo(-jobname=>$Job,-jobcategory=>'work',-jobinfo=>'customer_code') ;

##
##############################################################################################################
try {

	my $customer_code = $IKM->get_jobinfo(-jobname=>$Job,-jobcategory=>'work',-jobinfo=>'customer_code') ;

	show_loading("判断是否选择料号..",0,position=>'n');
	unless( $Job){
		$GUI->msgbox(-icon=>'error',-text=>"请先选择料号后再执行脚本!");
        return 'Cancel';
	}
	
	##
	update_loading("检查料号${Job}是否存在 ，请稍候..",0,position=>'n');
	unless ( $GEN->isJobExists(job=>$Job) ){
        $GUI->msgbox(-icon=>'error',-text=>"料号 ${Job} 在Genesis中不存在, 请检查!");
        return 'Error';
    }
	
	##
	update_loading("正在打开料号${Job} ，请稍候..",0,position=>'n');
	$GEN->openJob(job=>$Job) unless ($GEN->isJobOpen(job=>$Job));
	
	##
	update_loading("过滤工作step...",0,position=>'n');
	my ($pcs_steps,$array_steps) = get_work_step();
	return 'Cancel' if $pcs_steps eq 'Cancel';
	
	##
	update_loading("过滤层别...",0,position=>'n');
	my $ans_layer = select_work_layer();
	return 'Cancel' if $ans_layer eq 'Cancel';
    my @drills = @{$ans_layer};
	

	##
    my $drill_info;
	my $drill_count_info ;
    foreach my $layer(@drills){
		
			if(scalar(@$pcs_steps) > 0){
				foreach my $step(@$pcs_steps){
					next if($GEN->isLayerEmpty(job=>$Job,step=>$step,layer=>$layer));

					$GEN->openStep(job=>$Job,name=>$step);
					# $GEN->COM("tools_show,layer=$layer");
					# $GEN->COM("tools_set,layer=drl,thickness=0,user_params=,slots=by_length");
					update_loading("请设定为by length",0,position=>'n');
					$GEN->COM('tools_show',layer=>$layer);
					my $ans = $GEN->PAUSE('Please Set By Length!');
					return 'Cancel' unless $ans eq 'OK';

					my $tool = $GEN->getTool(job=>$Job,step=>$step,layer=>$layer,units=>$PAR->{units},hashkey=>['shape','type','drill_size','slot_len','finish_size']);
					if(defined $drill_info and exists $drill_info->{$layer}){
						foreach my $hashkey(keys %$tool){
							if(exists $drill_info->{$layer}{$hashkey}){
								$drill_info->{$layer}{$hashkey}{pcs_count} += $tool->{$hashkey}{count} ;
							}
						}
					}else{
						$drill_info->{$layer} = $tool ;
						foreach my $hashkey(keys %$tool){
							$drill_info->{$layer}{$hashkey}{pcs_count} += $tool->{$hashkey}{count} ;
						}
					}

					my @feat = $GEN->getFeatures(job=>$Job,step=>$step,layer=>$layer);
					$drill_count_info->{pcs_count} += scalar(@feat);
					$GEN->closeStep();
				}
			}
			if(scalar(@$array_steps) > 0){
				foreach my $step(@$array_steps){
					next if($GEN->isLayerEmpty(job=>$Job,step=>$step,layer=>$layer));
					$GEN->openStep(job=>$Job,name=>$step);
					# $GEN->COM("tools_show,layer=$layer");
					# $GEN->COM("tools_set,layer=drl,thickness=0,user_params=,slots=by_length");
					update_loading("请设定为by length",0,position=>'n');
					$GEN->COM('tools_show',layer=>$layer);
					my $ans = $GEN->PAUSE('Please Set By Length!');
					return 'Cancel' unless $ans eq 'OK';

					my $tool = $GEN->getTool(job=>$Job,step=>$step,layer=>$layer,units=>$PAR->{units},hashkey=>['shape','type','drill_size','slot_len','finish_size']);
					if(defined $drill_info and exists $drill_info->{$layer}){
						foreach my $hashkey(keys %$tool){
							if(exists $drill_info->{$layer}{$hashkey}){
								$drill_info->{$layer}{$hashkey}{array_count} += $tool->{$hashkey}{count} ;
							}
						}
					}else{
						$drill_info->{$layer} = $tool ;
						foreach my $hashkey(keys %$tool){
							$drill_info->{$layer}{$hashkey}{array_count} += $tool->{$hashkey}{count} ;
						}                
					}
					my @feat = $GEN->getFeatures(job=>$Job,step=>$step,layer=>$layer);
					$drill_count_info->{array_count} += scalar(@feat);
					$GEN->closeStep();
				}
			}
			
    }
	update_loading("正在上传钻孔数据",0,position=>'n');

# $GUI->debug(-text=>dump($drill_info));
    my $return = $IKM->delete(-table=>'pdm_job_cam_drill',-where=>{job_id=> $JOB_ID});
    my $index = 1 ;
	my $drill_org_data ;
    foreach my $layer(keys %$drill_info){
        my $datalist ;
        my $tool_num = 1 ;
		# foreach (sort{$a->{drill_size} <=> $b->{drill_size}} values %{$drill_info->{$layer}}){
		# 	if($_->{finish_size} =~ /\?+/i){
		# 		$_->{finish_size} = $_->{drill_size}
		# 	}
		# }
        foreach my $item(sort{$a->{drill_size} <=> $b->{drill_size}} values %{$drill_info->{$layer}}){
			$item->{slot_len} = $item->{slot_len} == 0 ? undef : $item->{slot_len};
			if($layer =~ /^ls\d+\-\d+/){
				$item->{min_tol} = 12.7 ;
				$item->{max_tol} = 12.7 ;
			}else{
				##公差
				if($customer_code =~ /to/){
					if($item->{drill_size} <= 304.8){
						$item->{min_tol} = 101.6 ;
						$item->{max_tol} = 0 ;
					}else{
						if($item->{type} eq 'non_plated'){
							$item->{min_tol} =50.8 ;
							$item->{max_tol} = 50.8 ;
						}else{
							$item->{min_tol} = 50.8 ;
							$item->{max_tol} = 50.8 ;
						}
					}
				}else{
					if($item->{type} eq 'non_plated'){
						$item->{min_tol} = 50.8 ;
						$item->{max_tol} = 50.8 ;
					}else{
						$item->{min_tol} = 76.2 ;
						$item->{max_tol} = 76.2 ;
					}
				}
			}


			my $step = 'PCS';
			my $process = 'second';
			my $attr_data = {
								step=>'pcs',
								process=>'second',
								count=>$item->{pcs_count},
								org_info=>$item
							};
			
			my $jsonStr = $json->encode($attr_data);
			my $seq = $index + $tool_num / 100 ;
			$seq .= '' ;




            my $data = {
                job_id=> $JOB_ID,
                layer_name=> $layer,
                tool_num=> 'T'.sprintf("%02s",$tool_num),
                # tool_flag=> $tool_num,
                tool_type=> $item->{shape},
                drill_type=>$item->{type},
                drill_size => sprintf("%.3f",$item->{drill_size}),,
                drill_slot_length=> $item->{slot_len},
                finish_size => sprintf("%.3f",$item->{finish_size}),###此处后续改为drill_size
                finish_slot_length=> $item->{slot_len},
                size_tol_lower=> $item->{min_tol}||0,
                size_tol_upper=> $item->{max_tol}||0,
                pcs_count=> $item->{pcs_count}||0,
                # array_count=> $item->{array_count}||0,
                seq=>$seq ,
                attr_data=> $jsonStr   # {"allowance": 2, "org_layer_name": "hhhh"}
            };
            push @$datalist ,$data;
            $tool_num ++ ;


			my $org_data = $data;
			$org_data->{attr_data} = $attr_data ;
			push @{$drill_org_data->{$layer}} , $org_data ;

        }
		if(scalar(@$datalist) > 0){
			# $drill_org_data->{$layer} = $datalist ;
			$IKM->batch_insert(
				-table=>'pdm_job_cam_drill',
				-field=>['job_id','layer_name','tool_num','tool_flag','drill_type','tool_type','drill_size','drill_slot_length','finish_size','size_tol_lower','size_tol_upper','finish_slot_length','pcs_count','array_count','seq','attr_data'],
				-data=>$datalist
			) 
		}
    }
	##记录钻孔原稿信息，用于钻孔模块载入原稿
	if(defined $drill_org_data){
		$IKM->save_jobinfo(-jobname=>$Job,-jobcategory =>'work',-jobinfohash=>{'drill_org_data'=>$drill_org_data}) ;
		#$GUI->debug(dump($drill_org_data));
	}

	#记录报价需要信息
	#原始钻孔数量
	if($IKM->get_jobinfo(-jobname=>$Job,-jobcategory=>'work',-jobinfo=>'shipping_mode') eq 'single'){
		$IKM->save_jobinfo(-jobname=>$Job,-jobcategory =>'work',-jobinfohash=>{'org_pcs_drl_count'=>$drill_count_info->{pcs_count}}) ;
	}else{
		my $pcs_count_per_set = $IKM->get_jobinfo(-jobname=>$Job,-jobcategory=>'work',-jobinfo=>'pcs_count_per_set') ;
		$IKM->save_jobinfo(-jobname=>$Job,-jobcategory =>'work',-jobinfohash=>{'org_array_drl_count'=>$drill_count_info->{pcs_count}*$pcs_count_per_set + $drill_count_info->{array_count}}) ;
	}
	

	#上传叠层模块钻孔信息
    my $cam_drill_structure ;
    my $layerCount = $GEN->getLayerCount(job=>$Job);
	foreach my $step(@$pcs_steps){
		$GEN->openStep(job=>$Job,name=>$step);
		foreach my $layer(sort{$matrix{$a}{row}<=>$matrix{$b}{row}} @drills){
			my $drill = $matrix{$layer} ;
			$GEN->clearLayers();
			$GEN->affectedLayer( mode=>'all',affected=>'no' );
			my $drill_info = {} ;
			my $drl_start_num = $drill->{'drl_start_num'} - 0 ;
			my $drl_end_num = $drill->{'drl_end_num'} - 0 ;
			$drill_info->{drl_start_num} = $drl_start_num ;
			$drill_info->{drl_end_num} = $drl_end_num ;
			my $drl_side = "None" ;
			if($layerCount / 2 >= $drl_start_num){
				$drl_side = "Top"
			} else {
				$drl_side = "Bot"
			}
			$drill_info->{drl_side} = $drl_side ;
			my $drl_filler = "None" ;

			# $GUI->debug(dump($drill->{type},$drl_start_num,$drl_end_num ));	

			if($drill->{type} == "laser_drill"){
				$drill_info->{drl_type} = "Laser" ;
				$drill_info->{drl_name} = "Laser".$drl_start_num."-".$drl_end_num ;
				$drill_info->{drl_tech} = "LDD" ;
				# // 计算此层的理论 top  bot
				if($drl_side == "Top"){
					if(($drl_start_num-1)==0){ $drl_filler = "None" }
					else {
						my $top_l = "laser".($drl_start_num-1)."-".($drl_end_num-1) ;
						if($GEN->isLayerExists(job=>$Job,layer=>$top_l)){
							$GEN->clearLayers();
							$GEN->selClearFeature();
							$GEN->workLayer(name=>$top_l,display_number=>2,clear_before=>'yes');
							$GEN->selRefFeat(
								layers=>$drill->{odb_name},
								use=>'filter',
								mode=>'touch',
							);
							if($GEN->getSelectCount() > 0){
								$GEN->selClearFeature();
								$drl_filler="Via Filling" ;
							}
						}
					}
					my $bot_l = "laser".($drl_start_num+1)."-".($drl_end_num+1) ;
					if($GEN->isLayerExists(job=>$Job,layer=>$bot_l)){
						$GEN->clearLayers();
						$GEN->selClearFeature();
						$GEN->workLayer(name=>$bot_l,display_number=>2,clear_before=>'yes');
						$GEN->selRefFeat(
							layers=>$drill->{odb_name},
							use=>'filter',
							mode=>'touch',
						);
						if($GEN->getSelectCount() > 0){
							$GEN->selClearFeature();
							$drill_info->{drl_overlap}="Yes" ;
						}else{
							$drill_info->{drl_overlap}="No" ;
						}
					}else{
						$drill_info->{drl_overlap}="No" ;
					}
				}elsif ($drl_side == "Bot"){
					if(($drl_end_num-$layerCount)==0){ $drl_filler = "None" }
					else {
						my $top_l = "laser".($drl_start_num+1)."-".($drl_end_num+1);
						if($GEN->isLayerExists(job=>$Job,layer=>$top_l)){
							$GEN->clearLayers();
							$GEN->selClearFeature();
							$GEN->workLayer(name=>$top_l,display_number=>2,clear_before=>'yes');
							$GEN->selRefFeat(
								layers=>$drill->{odb_name},
								use=>'filter',
								mode=>'touch',
							);
							if($GEN->getSelectCount() > 0){
								$GEN->selClearFeature();
								$drl_filler="Via Filling" ;
							}
						}
					}
					my $bot_l = "laser".($drl_start_num-1)."-".($drl_end_num-1) ;
					if($GEN->isLayerExists(job=>$Job,layer=>$bot_l)){
						$GEN->clearLayers();
						$GEN->selClearFeature();
						$GEN->workLayer(name=>$bot_l,display_number=>2,clear_before=>'yes');
						$GEN->selRefFeat(
							layers=>$drill->{odb_name},
							use=>'filter',
							mode=>'touch',
						);
						if($GEN->getSelectCount() > 0){
							$GEN->selClearFeature();
							$drill_info->{drl_overlap}="Yes" ;
						}else{
							$drill_info->{drl_overlap}="No" ;
						}
					}else{
						$drill_info->{drl_overlap}="No" ;
					}
				}
			} else {
				$GEN->clearLayers();
				$GEN->workLayer(name=>$drill->{odb_name},display_number=>2,clear_before=>'yes');
				$GEN->selectByFilter(
					attribute=>[{attribute=>'.drill',option=>'plated'}],
					profile=>'all',
				);
				if($GEN->getSelectCount()>0){
					$GEN->selClearFeature();
					$drill_info->{drl_type} = "PTH" ;
					if($drl_end_num - $drl_start_num == 1){$drl_filler = "Resin Plugin"}
					$drill_info->{drl_name} = "PTH".$drl_start_num."-".$drl_end_num ;
				}else{
					$drill_info->{drl_type} = "NPTH" ;
					$drill_info->{drl_name} = "NPTH".$drl_start_num."-".$drl_end_num ;
				}
			}
			$drill_info->{drl_filler} = $drl_filler ;
			$drill_info->{drl_zones} = "{A}" ;
			# my $jsonStr = $json->encode($drill_info);
			push @$cam_drill_structure , $drill_info ;
		}
		my @is_via_filling = grep {$_ eq "Via Filling"} @$cam_drill_structure;
		if(scalar(@is_via_filling) > 0){
			foreach (@$cam_drill_structure){
				if($_->{drl_type} eq 'Laser' and $_->{drl_filler} eq 'None'){
					$_->{drl_filler} = "Via Filling" ;
				}
			}
		}
		last;
	}

	$IKM->save_jobinfo(-jobname=>$Job,-jobcategory=>'work',-jobinfohash=>{'cam_drill_structure'=>$json->encode($cam_drill_structure)});

	hide_loading();
	##保存料号
	if( $PAR->{save_job} =~ /yes/i ){
		show_loading("$Job 正在保存料号，请稍候...",0,position=>'n');
		$GEN->checkInout(job=>$Job,mode=>'out');
		$GEN->saveJob(job=>$Job);
		hide_loading();
	}
	
    ###output and return status, if genesis error, it will output genesis error command
	unless ($GEN->{STATUS}){
		return $Return;
	}
	else{
		$GUI->msgbox(-icon=>'error',-text=>join("\n",@{$GEN->{STATUS}}));
		#addFlowNotes(-notes=>"   Genesis Error:\n ".join("\n   ",@{$GEN->{STATUS}}));
		return 'Error';
	}
}

catch Error::Simple with {
	my $error = shift;
	$GUI->msgbox(-icon=>'error',-text=>$error);
	return 'Error';
}
finally{

};
######################################################################################
sub get_work_step {
	update_loading("选择工作step...",0,position=>'n');
    my ($pcs_steps,$array_steps);
    my @steps =  $GEN->getStepList(job=>$Job);
	if ( @steps == 0 ) {
		$GUI->msgbox(-icon=>'error',-text=>'在料号中没有Step存在,你将退出!');
		return 'Cancel';
	}
	elsif (@steps != 0){
		push @$pcs_steps ,grep(/$PAR->{pcs_step_filter}/,@steps);
		push @$array_steps ,grep(/$PAR->{array_step_filter}/,@steps);
	}
    if($pcs_steps == 0 and $array_steps == 0){
        $GUI->msgbox(-icon=>'error',-text=>'在料号中没有脚本参数配置的Step存在,你将退出!');
        return 'Cancel' ;
    }

	return ($pcs_steps,$array_steps);
}

sub select_work_layer {
	my %par = @_;
	update_loading("过滤层别...",0,position=>'n');
	my %tmp_matrix;
    my @drill;
	# 获取工作层
	foreach my $layer (sort {$matrix{$a}{row} <=> $matrix{$b}{row}}  keys %matrix) {
		next unless $matrix{$layer}{context} eq 'board';
		if ($matrix{$layer}{tl_type} eq 'drill') {
			push @drill,$layer;
			$tmp_matrix{drill}{$layer} = $matrix{$layer};
		}
	}
	##
	if ( $PAR->{is_select_lyr} =~ /yes/i ) {
		@drill = $GUI->select_layer(
			-title=>'请选择工作层别',
			-layermatrix=>$tmp_matrix{drill},
			-default => [keys %{$tmp_matrix{drill}}],
			-selectmode => 'multiple');#single
		return 'Cancel' unless(@drill);
	}
	return \@drill;
}
